local name = "image"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    
    if not opt.image then
        opt.imageData = love.image.newImageData(opt.path)
        opt.image = love.graphics.newImage(opt.imageData)
    end
    if opt.noFrame then
        opt.noFill = true
        opt.noStroke = true
    end
    
    ---interact
    if opt.disabled then
        opt.state = "disabled"
    else
        core:updateState(opt)
    end
    ---draw
    core:applyLayout(opt)
    opt.draw = opt.draw or core.render[name]
    opt.style = opt.style or core.style
    core:registerDraw(opt.draw ,{opt.style,opt})
    
    return opt
end