local name = "menu"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    core:applyLayout(opt)
    ---interact
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    if opt.layout then 
        if opt.vert then
            opt.rowH = opt.rowH or core.layout.ih + core.layout.rs
        else
            opt.colW = opt.colW or core.layout.iw + core.layout.cs
        end
    end
    if opt.disabled then        
        return opt 
    end
    opt.choose = nil
    if opt.vert  then
        if opt.rowH then
            opt.h = opt.rowH * #opt.children
        else
            opt.rowH = opt.h / #opt.children
        end
    else
        if opt.colW then
            opt.w = opt.colW * #opt.children
        else
            opt.colW = opt.w / #opt.children
        end
    end
    for i , child in ipairs(opt.children) do
        child.noStroke = true
        child.noRound = true
        child.noGrad = true
        child.font = opt.font
        child.container = opt.container
        if child.toggle == nil then child.toggle = false end
        if opt.vert then
            child.x = opt.x
            child.y = opt.y + (i-1) * opt.rowH
        else
            child.x = opt.x + (i-1)*opt.colW
            child.y = opt.y
        end
        child.w = opt.colW or opt.w
        child.h = opt.rowH or opt.h
        if child.y+child.h>opt.y+opt.h then break end
        if child.text then
            core:doWidget("button",child)
        elseif child.path then
            core:doWidget("image",child)
        end
        if child.toggle then
            if child.sub then
                if opt.vert then
                    child.sub.x = child.x + child.w
                    child.sub.y = child.y
                else
                    child.sub.x = child.x
                    child.sub.y = child.y + child.h
                end
                if child.sub.vert then
                    child.sub.w = child.sub.w or child.w
                    child.sub.h = child.sub.h or #child.sub.children * child.h
                else
                    child.sub.w = child.sub.w or #child.sub.children * child.w
                    child.sub.h = child.sub.h or child.h
                end
                core:doWidget("menu",child.sub)
                if child.sub.choose then
                    opt.choose = child.sub.choose
                    child.toggle = false
                end
            else
                child.toggle = false
                opt.choose = child
            end
        end
    end
        
    opt.panel = opt.panel or {x = opt.x,y = opt.y,w=opt.w,h=opt.h,container = opt.container}
    opt.panel.x = opt.x
    opt.panel.y = opt.y
    core:doWidget("panel",opt.panel)
    --opt.draw = opt.draw or core.render[name]
    --opt.style = opt.style or core.style
    --core:registerDraw(opt.draw ,{opt.style,opt})
    
    return opt
end