local name = "number"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    ---interact
    core:applyLayout(opt)
    opt.submit = false
    if opt.disabled then
        opt.state = "disabled"
    else
        opt.input = opt.input or {x = opt.x,y = opt.y,w=opt.w,h=opt.h,text = tostring(opt.value),
            opt = opt.font,container = opt.container}
        opt.step = opt.step or 1
        local step = opt.step
        local input = opt.input
        input.x = opt.x
        input.y = opt.y
        
        core:doWidget("text",input)
        opt.active = false
        if input.submit then
            if opt.format then
                input.text = string.format(opt.format,input.text)
            end
            opt.value = tonumber(input.text) or 0
            input.text = tostring(opt.value)
            opt.submit = opt.value
        elseif input.editing then
            opt.active = true
        elseif input.hovered and core.key then
            local k = core.key
            if k == "left" then
                opt.value = opt.value-step
            elseif k == "right" then
                opt.value = opt.value+step
            elseif k == "up" then
                opt.value = opt.value-10*step
            elseif k == "down" then
                opt.value = opt.value+10*step
            end
            input.text = tostring(opt.value)
            opt.submit = true
        else
            input.text = tostring(opt.value)
        end
        
    end
    core:updateBound(opt)
    ---draw
    return opt
end