local name = "slider"
local spacing = 2
local function getValue(opt,block)
    local rate
    if opt.vert then
        rate = (block.y-spacing - opt.y) / (opt.h - spacing*2 - block.h)
    else
        rate = (block.x-spacing - opt.x) / (opt.w - spacing*2 - block.w)
    end
    opt.value = opt.min + rate * (opt.max - opt.min )
    opt.value = math.floor(opt.value/opt.step+0.5)*opt.step
    opt.value = math.min(opt.max,opt.value)
    opt.value = math.max(opt.min,opt.value)
end

local function getPos(opt,block)
    local rate = (opt.value - opt.min) / (opt.max - opt.min)
    if opt.vert then
        block.x = opt.x + spacing
        block.y = opt.y + rate * (opt.h - spacing * 2 - block.h) + spacing
    else
        block.x = opt.x + rate * (opt.w - spacing * 2 - block.w) + spacing
        block.y = opt.y + spacing
    end
end


return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    core:applyLayout(opt)
    opt.draw = opt.draw or core.render[name]
    opt.style = opt.style or core.style
    ---interact
    opt.step = opt.step or (opt.max - opt.min)/100
    opt.submit = false
    if not opt.block then
        local block = {}
        if opt.vert then
            block.w = opt.w - spacing * 2
            block.h = block.w
        else
            block.h = opt.h - spacing * 2
            block.w = block.h
        end
        getPos(opt,block)
        block.noOffset = true
        opt.block = block
    end
    
    local block = opt.block
    block.container = opt.container

    if opt.disabled then
        opt.state = "disabled"
    else
        core:doWidget("block",opt.block)
        if core:isActive(block) then
            opt.active = true
            if opt.vert then
                block.y = math.max(opt.y+spacing,
                    math.min(block.y + core.mouse_dy,opt.y+opt.h-spacing-block.h))
            else
                block.x = math.max(opt.x+spacing,
                    math.min(block.x + core.mouse_dx,opt.x+opt.w-spacing-block.w))
            end
            getValue(opt,block)
        elseif core:anyActive() then
            opt.active = false
            getPos(opt,block)
        else
            opt.active = false
            getValue(opt,block)
            getPos(opt,block)
        end
    end
    
    if core:wasActive(block) then
        opt.submit = opt.value 
    end
    
    opt.value = math.min(opt.max,opt.value)
    opt.value = math.max(opt.min,opt.value)
    ---draw
    opt.text = tostring(opt.value)
    core:registerDraw(opt.draw ,{opt.style,opt})
    core:updateBound(opt)
    return opt
end