local name = "tab"

local function newBtn(core,opt)
    local sx,sy = 1,1
    local offx,offy = 0,0
    local x,y,w,h = opt.x,opt.y,opt.w,opt.h
    local state = opt.state
    local style = opt.style or core.style
    local rx,ry = style.roundCorner.rx,style.roundCorner.ry
    opt.noOffset = true
    opt.noScale = true
    local font = opt.font.normal.obj
    local fw,fh = font:getWidth("W"),font:getHeight("H")
    local ss = fh+2
    opt.title_h = ss
    local bw = fh - 2
    local xx = x
    local container = {x,y,w,h,rx,ry}
    opt.tab_btn = opt.tab_btn or {}
    opt.close_btn = opt.close_btn or {}
    for i, child in ipairs(opt.children) do
        if not child.hide then
            local tw = font:getWidth(child.title) + rx * 2
            local ww = opt.close and tw+ bw + 2 or tw+2
            opt.tab_btn[i] = opt.tab_btn[i] or {
                text = child.title,
                x = xx,
                y = y+1,
                w = ww ,
                h = fh,
                toggle = false,
                noOffset = true,
                noScale = true,
                noRound = true,
                noGrad = true,
                container = {x,y,w,h,rx,ry},
                font = opt.font
                }
            opt.close_btn[i] = opt.close_btn[i] or {
                x = xx + opt.tab_btn[i].w - bw - 1,
                y = y+1,
                w = bw,
                h = bw,
                noStroke = true,
                shape = "check"
            }
            
            xx = xx + ww + 2
            opt.tab_w = xx - x
        end
        opt.btn_count = i
    end
end

local function update(core,opt)
    local sx,sy = 1,1
    local offx,offy = 0,0
    local x,y,w,h = opt.x,opt.y,opt.w,opt.h
    local style = opt.style or core.style
    local rx,ry = style.roundCorner.rx,style.roundCorner.ry
    opt.noOffset = true
    opt.noScale = true
    local state = opt.state
    local font = opt.font.normal.obj
    local fw,fh = font:getWidth("W"),font:getHeight("H")
    local ss = fh+2
    opt.title_h = ss
    local bw = fh - 2
    local xx = x + rx
    local container = {x,y,w,h,rx,ry}
    if not opt.tab_btn then
        newBtn(core,opt)
    end
    for i, child in ipairs(opt.children) do
        if not child.hide then
            local tw = font:getWidth(child.title) + rx * 2
            local ww = opt.close and tw+ bw + 2 or tw+2
            local b = opt.tab_btn[i]
            b.x = xx
            b.y = y+1
            b.w = ww
            b.h = fh
            b.container = container
            local c = opt.close_btn[i]
            c.x = xx + b.w - bw - 1
            c.y = y+1
            c.w = bw
            c.h = bw
            
            if b.toggle and opt.close then
                core:doWidget("shape",c)
            end
            core:doWidget("button",b)
            if b.hit then
                opt.index = i
                for j,k in pairs(opt.tab_btn) do
                    k.toggle = false 
                end
            end
            
            if c.hit then
                child.hide = true
                opt.tab_btn = nil
                opt.index = 1
                newBtn(core,opt)
                break
            end
            xx = xx + ww + 2
            opt.tab_w = xx - x
        end
    end
end




return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    core:applyLayout(opt)
    ---interact
    opt.index = opt.index or 1
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    if opt.disabled or opt.hide then
        opt.state = "disabled"
    else
        update(core,opt)
        local frame = opt.children[opt.index]
        if not frame or frame.hide then
            for i,child in ipairs(opt.children) do
                if not child.hide then
                    opt.index = i
                    frame = child
                    break
                end
            end
        end
        
        frame.layout = nil
        frame.x = opt.x
        frame.y = opt.y
        if not core.mouse_down then
            frame.w = opt.w
            frame.h = opt.h
        end
        frame.window = opt.window
        frame.grid = frame.grid or opt.grid
        frame.cell = frame.cell or opt.cell
        frame.noHead = true
        frame.parent = opt
        core:doWidget("frame",frame)
    end
    core:updateState(opt)
    ---children
    if opt.movable then
        if not core.mouse_down then
            opt.grab = nil
        elseif opt.state == "active" then
            opt.grab = "move"
            if opt.layout then opt.layout = nil end
        end
    end
    if opt.grab == "move" then
        opt.x = opt.x + core.mouse_dx
        opt.y = opt.y + core.mouse_dy
    end
    ---draw
    
    opt.draw = opt.draw or core.render[name]
    opt.style = opt.style or core.style
    if not opt.hide then
        core:registerDraw(opt.draw ,{opt.style,opt})
    end
    return opt
end