local editor = {
    x = 350,y = 350,w = 500, h = 500,
    title = "style editor",
    close = true,
    min = true,
    window = {w = 500,h = 500}, noSlider = true,movable =true,resizable = true,
    cell = {150,20},
    children = {
        {type = "label",text = "状态",layout = "right"},
        {type = "list", text = "normal",layout = "right",options = {
                {text = "normal"},
                {text = "hovered"},
                {text = "active"},
                {text = "disabled"}
                }},
        {type = "label",text = "项目",layout = "next"},
        {type = "label",text = "属性",layout = "right2x1"},
        
        {type = "label",text = "填充颜色",layout = "next"}, --5
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
        {type = "label",text = "描边颜色",layout = "next"}, --8
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
    
        {type = "label",text = "描边宽度",layout = "next"}, --11
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 10},
        
        {type = "label",text = "圆角半径",layout = "next"}, --13
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 30},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 30},
        
        
        {type = "label",text = "渐变染色",layout = "next"}, --16
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
        {type = "label",text = "渐变颜色0",layout = "next"}, --19
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
        {type = "label",text = "渐变颜色1",layout = "next"},    --22
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
        {type = "label",text = "渐变类型",layout = "next"}, --25
         {type = "list", text = "请选择", options = {
                {text = "vertical"},
                {text = "horizonal"},
                {text = "radius"}
                 },layout = "right"},
        
        {type = "button",text = "刷新渐变",layout = "right",
            func = function() ui.style.gradient.mesh = nil end},
        {type = "label",text = "交互位移",layout = "next"}, --28
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 10},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 10},
        
        
        {type = "label",text = "交互缩放",layout = "next"}, --31
        {type = "slider",layout = "right",value = 0.1,step = 0.01,min=0,max = 2},
        {type = "slider",layout = "right",value = 0.1,step = 0.01,min=0,max = 2},
        
        
        {type = "label",text = "字体",layout = "next"}, --34
        {type = "text",layout = "right",text = "路径"},
        {type = "slider",layout = "right",value = 0.1,step = 1,min=6,max = 30},
        
        {type = "label",text = "字体颜色",layout = "next"}, --37
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        
        {type = "label",text = "图片颜色",layout = "next"}, --40
        {type = "colorpicker",layout = "right"},
        {type = "slider",layout = "right",value = 1,step = 0.01,min=0,max = 1},
        {type = "image",layout = "next3x3",path = "/love-ball.png",
            aline = {x = "center",y = "center"},rot = 0}
        }
    }

local function bind()
    local c = editor.children
    local state = c[2].text
    ui:dataBind(ui.style.fillColor[state],c[6],"rgb","color")
    ui:dataBind(ui.style.fillColor[state],c[7],"alpha","color")
    ui:dataBind(ui.style.strokeColor[state],c[9],"rgb","color")
    ui:dataBind(ui.style.strokeColor[state],c[10],"alpha","color")
    ui:dataBind(ui.style.strokeWidth,c[12],state,"number")
    ui:dataBind(ui.style.roundCorner,c[14],"rx","number")
    ui:dataBind(ui.style.roundCorner,c[15],"ry","number")
    
    ui:dataBind(ui.style.gradient.color[state],c[17],"rgb","color")
    ui:dataBind(ui.style.gradient.color[state],c[18],"alpha","color")
    
    ui:dataBind(ui.style.gradient.color0,c[20],"rgb","color")
    ui:dataBind(ui.style.gradient.color0,c[21],"alpha","color")
    
    ui:dataBind(ui.style.gradient.color1,c[23],"rgb","color")
    ui:dataBind(ui.style.gradient.color1,c[24],"alpha","color")
    
    ui:dataBind(ui.style.gradient,c[26],"type","string")
    
    ui:dataBind(ui.style.offset[state],c[29],"x","number")
    ui:dataBind(ui.style.offset[state],c[30],"y","number")
    
    ui:dataBind(ui.style.scale[state],c[32],"x","number")
    ui:dataBind(ui.style.scale[state],c[33],"y","number")
    
    ui:dataBind(ui.style.font[state],c[35],"path","string")
    ui:dataBind(ui.style.font[state],c[36],"size","number")
    
    ui:dataBind(ui.style.fontColor[state],c[38],"rgb","color")
    ui:dataBind(ui.style.fontColor[state],c[39],"alpha","color")
    
    ui:dataBind(ui.style.imageColor[state],c[41],"rgb","color")
    ui:dataBind(ui.style.imageColor[state],c[42],"alpha","color")
end

local styleEditor = {}

function styleEditor:init()
    bind()
end

function styleEditor:update(dt)
    ui.frame(editor)
    if editor.children[2].submit then
        bind()
    end
    
    editor.children[43].rot = editor.children[43].rot + dt
end

return styleEditor